-- ==========================================================
-- table of positions
-- ==========================================================
CarpetR = {}
InitMoveTable(CarpetR,0,1)

CarpetRotRight = function (date)
s = "right"
celestia:flash(s)

	if (CarpetR.V <= -3)
	 then CarpetR.V = CarpetR.V / 3
	elseif (CarpetR.V < -1)
	 then CarpetR.V = -1
	elseif (CarpetR.V == -1)
	 then CarpetR.V = 0
	elseif (CarpetR.V == 0)
	 then CarpetR.V = 1
	elseif (CarpetR.V >= 1)
	 then CarpetR.V = CarpetR.V * 3
	end

end
CarpetRotStop = function (date)
	MoveStop(CarpetR,date)
end
CarpetRotLeft = function (date)
	if (CarpetR.V >=3 )
	 then CarpetR.V = CarpetR.V / 3
	elseif (CarpetR.V > 1)
	 then CarpetR.V = 1
	elseif (CarpetR.V == 1)
	 then CarpetR.V = 0
	elseif (CarpetR.V == 0)
	 then CarpetR.V = -1
	elseif (CarpetR.V <= -1)
	 then CarpetR.V = CarpetR.V * 3
	end
end


-- ==========================================================
-- rotation commands
-- ---------------------------------------
-- TurnRight/stop/Left
cmds.FCTR = CarpetRotRight
cmds.Flying_Carpet_Turn_Right = CarpetRotRight
cmds.FCTS = CarpetRotStop
cmds.Flying_Carpet_Turn_Stop = CarpetRotStop
cmds.FCTL = CarpetRotLeft
cmds.Flying_Carpet_Turn_Left = CarpetRotLeft

-- ==========================================================
-- rotation method
-- ---------------------------------------

CarpetRot = function (date)
	local Angle = MoveNow (CarpetR,date)/minute

--s = "angle = "..Angle
--celestia:flash(s)

	return  yPi*celestia:newrotation( yAxis, Angle)
end

-- ---------------------------------------
-- RotateCarpet left or right

RotateCarpetProto = { } -- no args

-- constructor method

function RotateCarpetProto:new(o)
	o = o or {}
	setmetatable (o, self)
	self.__index = self

 	o.period = 1

	return o
end

-- orientation function

function RotateCarpetProto:orientation(tjd)

	local qNow = CarpetRot( tjd )
	return qNow.w, qNow.x, qNow.y, qNow.z

end

-- create new rotation object

function RotateCarpet(sscvals)

	return RotateCarpetProto:new(sscvals)

end

