-- ==========================================================
-- table of positions
-- ==========================================================
-- elevation (up/down)
CarpetE = {}
InitMoveTable(CarpetE,0,1)

CarpetElevUp = function (date)
	if (CarpetE.V <= -3)
	 then CarpetE.V = CarpetE.V / 3
	elseif (CarpetE.V < -1)
	 then CarpetE.V = -1
	elseif (CarpetE.V == -1)
	 then CarpetE.V = 0
	elseif (CarpetE.V == 0)
	 then CarpetE.V = 1
	elseif (CarpetE.V >= 1)
	 then CarpetE.V = CarpetE.V * 3
	end

end
CarpetElevStop = function (date)
	MoveStop(CarpetE,date)
end
CarpetElevDown = function (date)
	if (CarpetE.V >=3 )
	 then CarpetE.V = CarpetE.V / 3
	elseif (CarpetE.V > 1)
	 then CarpetE.V = 1
	elseif (CarpetE.V == 1)
	 then CarpetE.V = 0
	elseif (CarpetE.V == 0)
	 then CarpetE.V = -1
	elseif (CarpetE.V <= -1)
	 then CarpetE.V = CarpetE.V * 3
	end
end


-- ==========================================================
-- elevation commands
-- ---------------------------------------
-- go up/stop/down

cmds.FCVU = CarpetElevUp
cmds.Flying_Carpet_Vertical_Up = CarpetElevUp
cmds.FCVD = CarpetElevDown
cmds.Flying_Carpet_Vettical_Down = CarpetElevDown
cmds.FCVS = CarpetElevStop
cmds.Flying_Carpet_Vettical_Stop = CarpetElevStop

-- ==========================================================
-- elevation (up/down)
CarpetM = {}
InitMoveTable(CarpetM,0,1)

CarpetMoveFwd = function (date)
	if (CarpetM.V <= -3)
	 then CarpetM.V = CarpetM.V / 3
	elseif (CarpetM.V < -1)
	 then CarpetM.V = -1
	elseif (CarpetM.V == -1)
	 then CarpetM.V = 0
	elseif (CarpetM.V == 0)
	 then CarpetM.V = 1
	elseif (CarpetM.V >= 1)
	 then CarpetM.V = CarpetM.V * 3
	end

end
CarpetMoveStop = function (date)
	MoveStop(CarpetM,date)
end
CarpetMoveBack = function (date)
	if (CarpetM.V >=3 )
	 then CarpetM.V = CarpetM.V / 3
	elseif (CarpetM.V > 1)
	 then CarpetM.V = 1
	elseif (CarpetM.V == 1)
	 then CarpetM.V = 0
	elseif (CarpetM.V == 0)
	 then CarpetM.V = -1
	elseif (CarpetM.V <= -1)
	 then CarpetM.V = CarpetM.V * 3
	end
end

-- ==========================================================
-- horizontal motion commands
-- ---------------------------------------
-- go fwd/stop/back

cmds.FCMF = CarpetMoveFwd
cmds.Flying_Carpet_Move_Forward = CarpetMoveFwd
cmds.FCMB = CarpetMoveBack
cmds.Flying_Carpet_Move_Back = CarpetMoveBack
cmds.FCMS = CarpetMoveStop
cmds.Flying_Carpet_Move_Stop = CarpetMoveStop

-- ==========================================================
-- translation method
-- ---------------------------------------

CarpetTrans = function (date)
	local y = MoveNow (CarpetM,date)/minute

	local z = MoveNow (CarpetE,date)/minute

	return 0, y, z 
end

-- ---------------------------------------
-- motion method

TranslateCarpet = function (sscvals)

	local orbit = {}
	orbit.boundingRadius = 1e3

	function orbit:position (tjd)
		return CarpetTrans(tjd)
	end

return orbit
end

